# Contributing

Thank you for contributing to the project. We'd love to see your
issues and pull requests.

If you're creating a pull request, please consider these suggestions:

Fork, then clone the repo:

    git clone git@github.com:your-username/absinthe.git

Install the dependencies:

    mix deps.get

Make sure the tests pass:

    mix test

Make your change. Add tests for your change. Make the tests pass:

    mix test

Push to your fork (preferably to a non-`master` branch) and
[submit a pull request][pr].

[pr]: https://github.com/CargoSense/absinthe/compare/

We'll review and answer your pull request as soon as possible. We may suggest
some changes, improvements, or alternatives. Let's work through it together.

Some things that will increase the chance that your pull request is accepted:

* Write tests.
* Include `@typedoc`s, `@spec`s, and `@doc`s
* Try to match the style conventions already present (and Elixir conventions,
  generally).
* Write a [good commit message][commit].

Thanks again for helping!

[style]: https://github.com/thoughtbot/guides/tree/master/style
[commit]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
